<?php
/*
Plugin Name: Pagebar
Plugin URI: http://www.elektroelch.de/wp/pagebar.html
Description: Adds an advanced page navigation to Wordpress.
Version: 1.2
Author: Lutz Schr&ouml;er
Author URI: http://elektroelch.de
*/


/*  This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA   
*/

/*
      Original Script by: Lester Chan (http://www.lesterchan.net/portfolio/programming.php)
*/

/* --------------------------------------------------------------------------------------------- */
function showTooltip($tooltip, $tooltipText, $page)
{
  if ($tooltip)
    return ' title="' . $tooltipText . ' ' . $page .'"';
}  
/* --------------------------------------------------------------------------------------------- */

function wp_pagebar($params)
{
	global $request, $posts_per_page, $wpdb, $paged;
	
	/* Handle default values */
	if (! isset($params['before']))          { $params['before']       = ''; }
  if (! isset($params['after']))           { $params['after']        = ''; }	
  if (! isset($params['tooltip']))         { $params['tooltip']      = true; }		
  if (! isset($params['tooltip_text']))    { $params['tooltip_text'] = 'Page'; }		
  if (! isset($params['prev']))            { $params['prev']         = '&#9668;'; }	
  if (! isset($params['next']))            { $params['next']         = '&#9658;'; }	
  if (! isset($params['directions']))      { $params['directions']   = true; }	
	
	
	if (!is_single()) 
	{
		if (get_query_var('what_to_show') == 'posts') {
			preg_match('#FROM\s(.*)\sGROUP BY#siU', $request, $matches);
			$fromwhere = $matches[1];
			$numposts = $wpdb->get_var("SELECT COUNT(DISTINCT ID) FROM $fromwhere");
			$max_page = ceil($numposts /$posts_per_page);
		} else
			$max_page = 999999;
		
		if(empty($paged)) 
			$paged = 1;

		if($max_page > 1) 
		{
			
			echo '<div class="pagebar">' . $params['before'];
			
			if ($paged>1 && $params['directions'])
        echo '<a href="'.trim(get_pagenum_link($paged-1)).'" '.showToolTip($params['tooltip'],$params['tooltip_text'], $paged-1).'>'.$params['prev'].'</a> ';
			
			if ($paged >= 4) 
				echo '<a href="'.get_pagenum_link().'"'.showToolTip($params['tooltip'],$params['tooltip_text'], "1").'>1</a> <span class="break">...</span> ';
			
			for($i = $paged - 2 ; $i  <= $paged +2; $i++) {
				if ($i >= 1 && $i <= $max_page) {
					if($i == $paged) 
						echo '<span class="this-page">'.$i.'</span>';
					else 
						echo ' <a href="'.get_pagenum_link($i).'"'.showToolTip($params['tooltip'],$params['tooltip_text'], $i) .'>'.$i.'</a> ';
				}
			}
			if (($paged+2) < ($max_page)) 
				echo ' <span class="break">...</span> <a href="'.get_pagenum_link($max_page).'"'.showToolTip($params['tooltip'],$params['tooltip_text'], $max_page).'>'.$max_page.'</a>';

      if ($paged<$max_page && $params['directions'])
        echo ' <a href="'.get_pagenum_link($paged+1).'"'.showToolTip($params['tooltip'],$params['tooltip_text'], $paged+1).'>'.$params['next'].'</a>';

			echo $params['after'] . '</div>';
		}
	}
}
?>