<?php
// ========================================
// BloxPress - Custom Flickr Block
// ========================================
// 		author:   Kjell Bublitz
// 		created:  07.11.2006
// 		modified: 30.04.2006
// 		contact:  m3nt0r.de@gmail.com
// 		website:  www.bloxpress.org
// ========================================
/*
   BloxPress v2.0
   ----------------------
   Copyright (C) 2006, Kjell Bublitz
   www.bloxpress.org / kb@bloxpress.org

*/

if(!function_exists('fetch_rss'))
{
    require_once(dirname(__FILE__).'/../system/phplibs/rss_fetch.inc');
}

if(!function_exists('cutImageRSS'))
{
    function cutImageRSS($rss_desc)
    {
    	// this function gets only the good stuff and adds our own class to work with.
    	$string_arr = explode('<p>',$rss_desc);
    	$singlepic = $string_arr[2];
    	$string = str_replace('</p>','',$singlepic);
    	$string = str_replace('<img ','<img class="flickr" ',$string);

        echo $string;
    }
}

if(!function_exists('displayFlickrRSS'))
{
    function displayFlickrRSS($type,$user,$tag,$group,$display = 10)
    {
    	$show = $display;

    	switch($type) {
    		case "user":
    		    if($user != "") {
    		 	    $feedurl = "http://www.flickr.com/services/feeds/photos_public.gne?id=".$user."&format=rss_200";
    		    } else {
    		        echo "You have chosen to display a user stream, but the UserID-field was empty.";
    		        exit;
    		    }
    		break;

    		case "tag":
    		    if($tag != "") {
    		  	    $feedurl = "http://www.flickr.com/services/feeds/photos_public.gne?tags=".$tag."&format=rss_200";
    		  	} else {
        			echo "You have chosen to display a tag stream, but the tagfield was empty.";
        			exit;
    		  	}
    		break;

    		case "both":
        		if($user != "" and $tag != "") {
        			$feedurl = "http://www.flickr.com/services/feeds/photos_public.gne?id=".$user."&tags=".$tag."&format=rss_200";
        		} else {
        			echo "You wanted to combine UserID and Tag but one or both fields were empty";
        			exit;
        		}
    		break;

    		case "group":
    		    if($group != "") {
    			    $feedurl = "http://www.flickr.com/groups/".$group."/pool/feed/?format=rss_200";
    			} else {
    			    echo "You have chosen to display a group stream, but the groupfield was empty.";
    			    exit;
    			}
    		break;
    	}


    	if ( $feedurl )
    	{
    		// this is for the stupid magpie error message
    		// if feed returns nothing. i check then for empty
    		// and return a proper message
    		ini_set("display_errors", false);

    		$rss = fetch_rss($feedurl);

    		if($rss == "") {
    			echo "<small>Error fetching stream.</small>";
    		    exit;
    		}
    		$rss = $rss->items;

    		foreach ($rss AS $item)
    		{
    		  	if ($display == 0) {
    		  			echo "<br clear=\"all\" /><small><a href=\"".htmlentities($feedurl)."\" title=\"FeedURL\" rel=\"bookmark\">Subscribe this stream</a></small>";
    		  			break;
    		  	}
    			cutImageRSS($item['description']);
    			$display--;
    		}

    		// create new, delete old
    		$cookie = $type.";".$user.";".$tag.";".$group.";".$show;
    		$cookie_old = $_COOKIE['bp-flickr'];
    		setcookie("bp-flickr", $cookie_old, time()-1, "/"); // delete cookie
    		setcookie("bp-flickr", $cookie, time()+36000000, "/"); // set cookie 10000 hours
    	}
    }
}



// echo "<pre style='font-size:1.2em'>";
// print_r($_POST);
// echo "</pre>";

$type   = $_POST['type'];
$user   = $_POST['user'];
$tag    = $_POST['tag'];
$group  = $_POST['group'];
$show   = $_POST['show'];

displayFlickrRSS($type, $user, $tag, $group, $show);
?>