<?php
/*
   BloxPress2
   ----------------------
   Copyright (C) 2006, Kjell Bublitz
   www.bloxpress.org / kb@bloxpress.org

   Bloxpress Admin helpers

*/
session_start(); define('RELPATH', '../../../..');
require_once(RELPATH.'/wp-config.php');
require_once(RELPATH.'/wp-admin/admin-functions.php');
require_once(RELPATH.'/wp-admin/admin-db.php');
include_once('phplibs/class.xml.php');

// i dont know which, but some WP versions don't have this function
if ( !function_exists('check_ajax_referer') ) {
    function check_ajax_referer() {
    	$cookie = explode('; ', urldecode(empty($_POST['cookie']) ? $_GET['cookie'] : $_POST['cookie'])); // AJAX scripts must pass cookie=document.cookie
    	foreach ( $cookie as $tasty ) {
    		if ( false !== strpos($tasty, USER_COOKIE) )
    			$user = substr(strstr($tasty, '='), 1);
    		if ( false !== strpos($tasty, PASS_COOKIE) )
    			$pass = substr(strstr($tasty, '='), 1);
    	}
    	if ( wp_login( $user, $pass, true ) ) {
    		return true;
    	}
    	return false;
    }
}

// check referer and if user is allowed to do such actions.
if(!check_ajax_referer()){die('Wrong referer, dood');}
if(!current_user_can('switch_themes')){die('You have no rights for this');}

// Save Preset;
if($_GET['do'] == 'savePreset')
{
    $blocks = explode("B_",$_COOKIE['bp2apres']);
    foreach($blocks as $block){
        if($block) {
        $blocks_num = explode('_',$block);
        $blockdata = explode(',',$blocks_num[1]);
        $blockarr = array(
            'caption' => $blockdata[0],
            'file' => $blockdata[1],
            'message' => $blockdata[2]
            );
        $layout[$blocks_num[0]][] = $blockarr;
        }
    }

    $xmlLayout = array();
    for($c=0;$c < count($layout); $c++) {
        $xmlLayout['bloxpress']['column'][$c]['block'] = $layout[$c];
    }
    $dbPresets = get_option('bp_presets');
    $dbPresets[$_GET['t']][$_GET['p']] = $xmlLayout;
    update_option('bp_presets', $dbPresets);
    echo "Saved!";
}


// Remove Block
if($_GET['do'] == 'removeBlock')
{
    // read, find, remove, set
    $blocks = $_SESSION['bp2fileblocks'];
    for($i=0;$i < count($blocks);$i++){
        if(count($blocks[$i]) > 0) {
            if($blocks[$i]['file'] == $_GET['b'].'.php'){
                unset($blocks[$i]);
                unset($_SESSION['bp2fileblocks']);
                $_SESSION['bp2fileblocks'] = $blocks;
                break;
            }
        }
    }

    // create xml data
    $newblocks = array();
    if(is_array($blocks)){
        foreach($blocks as $block){ $newblocks[] = $block; }
        if(count($newblocks[0]) > 0) {
            $xmlblocks = array(); $xmlblocks['bloxpress']['block'] = $newblocks;
            $blocksxml = XML_serialize($xmlblocks);
        } else { $blocksxml = '<?xml version="1.0" ?>'; }
    }

    // write xml data
    if($handle = fopen(BP_WORKDIR.'/blocks.xml', 'w+')){
        if(fwrite($handle, $blocksxml)){ echo "Block deactivated successful :)"; }
        else {
            if($blocksxml == '<?xml version="1.0" ?>') {
                echo "Block deactivated successful :)";
            } else {
                echo "Update failed. Can't write.";
            }
        }
    } else { echo "Can't open xml file."; }

}


// Add Block
if($_GET['do'] == 'addBlock')
{
    // read, find
    $already = false;
    $blocks = $_SESSION['bp2fileblocks'];
    for($i=0;$i < count($blocks);$i++){
        if(count($blocks[$i]) > 0) {
            if($blocks[$i]['file'] == $_GET['b'].'.php'){
                $already = true;
            }
        }
    }

    if(!$already) {
        $temp = array();
        $temp['caption'] = urldecode($_GET['t']);
        $temp['file'] = urldecode($_GET['f']);
        $temp['message'] = urldecode($_GET['m']);
        $blocks[] = $temp;
        unset($_SESSION['bp2fileblocks']);
        $_SESSION['bp2fileblocks'] = $blocks;

        // create xml data
        $newblocks = array(); if(is_array($blocks)){
        foreach($blocks as $block){ $newblocks[] = $block; } }
        else { $newblocks = $blocks; } $xmlblocks = array();
        $xmlblocks['bloxpress']['block'] = $newblocks;
        $blocksxml = XML_serialize($xmlblocks);

        // write xml data
        if($handle = fopen(BP_WORKDIR.'/blocks.xml', 'w+')){
            if(fwrite($handle, $blocksxml)){ echo "Block activated successful :)"; }
            else{ echo "Update failed. Can't write."; }
        }else{ echo "Can't open xml file."; }
    }else{ echo "Already active"; }
}



// Save Block edits
if($_GET['do'] == 'editBlock')
{
    // read, find, update, set
    $blocks = $_SESSION['bp2fileblocks'];
    for($i=0;$i < count($blocks);$i++){
        if($blocks[$i]['file'] == $_GET['b'].'.php'){
            $blocks[$i]['caption'] = $_GET['t'];
            $blocks[$i]['message'] = $_GET['m'];
            unset($_SESSION['bp2fileblocks']);
            $_SESSION['bp2fileblocks'] = $blocks;
            break;
        }
    }

    // create xml data
    $newblocks = array(); foreach($blocks as $block){ $newblocks[] = $block; }
    $xmlblocks = array(); $xmlblocks['bloxpress']['block'] = $newblocks;
    $blocksxml = XML_serialize($xmlblocks);

    // write xml data
    if($handle = fopen(BP_WORKDIR.'/blocks.xml', 'w+')){
        if(fwrite($handle, $blocksxml)){ echo "Updated successful :)"; }
        else{ echo "Update failed. Can't write."; }
    }else{ echo "Can't open xml file."; }

}

echo '<script type="text/javascript">setTimeout(function() { Element.hide("info"); }, 700)</script>';
?>