<?php
/*
   BloxPress2
   ----------------------
   Copyright (C) 2006, Kjell Bublitz
   www.bloxpress.org / kb@bloxpress.org

   Bloxpress Adminpage: Blocks

*/
add_action('admin_menu', 'bloxpress_blocks');
function bloxpress_blocks() { add_submenu_page('themes.php', 'Bloxpress Blocks', 'Bloxpress Blocks', 5, BP_BASEDIR.'/system/admin_blocks.php', 'bloxpress_blocksHTML'); }

function bloxpress_blocksHTML()
{
    // Get the current Blocks.xml
    include_once(BP_BASEDIR.'/system/phplibs/class.xml.php');
    $xmlblocks = file_get_contents(BP_BASEDIR.'/system/workdir/blocks.xml');
    $phpblocks = XML_unserialize($xmlblocks);
    $blocks = $phpblocks['bloxpress']['block'];

    // Fix for XML Class and only one block
    if(is_array($blocks)) {
        $keyCheck = array_keys($blocks);
        if(in_array('caption', $keyCheck, TRUE)) {
             $temp = array($blocks); $blocks = $temp;
        }
    }

    // Always be fresh
    unset($_SESSION['bp2fileblocks']);
    $_SESSION['bp2fileblocks'] = $blocks;

    // Get Blocks and FileInfo
    if(is_dir(BP_BLOCKDIR)) {
        $blocksInfos = array(); $i=0;
        $blockdir = opendir(BP_BLOCKDIR);
        while (($blockfile = readdir($blockdir)) !== false) {
            if($blockfile != '.' && $blockfile != '..' && $blockfile != 'CVS' && $blockfile != 'icons'){
                $blockchunk = explode('.', $blockfile);
                $blocksInfos[$i] = bp_get_block_data(BP_BLOCKDIR.'/'.$blockfile);
                $blocksInfos[$i]['active'] = false;
                $blocksInfos[$i]['file'] = $blockfile;
                $blocksInfos[$i]['filechunk'] = $blockchunk[0];
                if(is_array($blocks)) {
                    foreach($blocks as $block) {
                        if($block['file'] == $blockfile){ $blocksInfos[$i]['active'] = true; break; }
                    }
                }
            }
            $i++;
        }
    }


?>

<?php if(get_option('bp_version')): ?>
<?php if($message){ ?><div id="message" class="updated fade"><p><?php echo $message ?></p></div><?php } ?>
<div id="dropmessage" class="updated" style="display:none;"></div>
<style type="text/css">
.block{background:#fafafa;}
</style>

<script src="<?php echo BP_BASEURL; ?>/system/javascript/libraries/prototype.js" type="text/javascript"></script>
<script src="<?php echo BP_BASEURL; ?>/system/javascript/scriptaculous/effects.js" type="text/javascript"></script>

<script type="text/javascript">
    function switchBlock(chunk, button) {
        $("info").innerHTML = ''; Element.show($("info"));
        button.innerHTML = button.innerHTML.replace(/^\s*|\s*$/g,"");
        if(button.innerHTML == 'Deactivate') {
            new Ajax.Updater('info', '<?php echo BP_BASEURL; ?>/system/admin_ajax.php?do=removeBlock&b='+chunk+'&cookie='+document.cookie, {evalScripts:true});
            button.innerHTML = 'Activate';
        } else {
            Element.cleanWhitespace($('file_'+chunk));
            var file = $('file_'+chunk).childNodes[0].innerHTML;
            var titel = $('file_'+chunk).childNodes[1].innerHTML;
            var message = $('file_'+chunk).childNodes[2].innerHTML;
            new Ajax.Updater('info', '<?php echo BP_BASEURL; ?>/system/admin_ajax.php?do=addBlock&b='+chunk+'&f='+file+'&t='+titel+'&m='+message+'&cookie='+document.cookie, {evalScripts:true});
            button.innerHTML = 'Deactivate';
        }
    }
    function editBlock(chunk, button) {
        Element.cleanWhitespace('file_'+chunk);
        var titel = $('file_'+chunk).childNodes[1].innerHTML;
        var message = $('file_'+chunk).childNodes[2].innerHTML;
        if(!titel.match('\b|<input|\b')) {
            Element.update($('file_'+chunk).childNodes[1], '');
            Element.update($('file_'+chunk).childNodes[2], '');

            titelInput = document.createElement('input');
            titelInput.value=titel; titelInput.id='cap'+chunk;
            titelInput.style.width = '120px';
            $('file_'+chunk).childNodes[1].appendChild(titelInput);

            messageInput = document.createElement('input');
            messageInput.value=message; messageInput.id='msg'+chunk;
            messageInput.style.width = '120px';
            $('file_'+chunk).childNodes[2].appendChild(messageInput);

            button.innerHTML = 'Save';
        } else {
            var formTitle = escape( $F('cap'+chunk) );
            var formMessage = escape($F('msg'+chunk));
            Element.update($('file_'+chunk).childNodes[1], $F('cap'+chunk));
            Element.update($('file_'+chunk).childNodes[2], $F('msg'+chunk));
            new Ajax.Updater('info', '<?php echo BP_BASEURL; ?>/system/admin_ajax.php?do=editBlock&b='+chunk+'&t='+formTitle+'&m='+formMessage+'&cookie='+document.cookie);
            button.innerHTML = 'Edit';
        }
    }
</script>

<!-- begin menu -->
<div class="wrap">

<h2>Block Administration</h2>
<p>Here you can activate and deactivate Blocks and also change their title and loading-message.</p>
<p>Note: If you deactivate a block it will also be removed from the layout and won't be generated any longer
even  it was in your layoutcookie. This does not apply to static layouts. If you have a deactivated block
setted in a layout it will load if a user switches to that layout. Then it is missing in the menu only.</p>

<div id="info" style="background:#fafafa;color:#44a"></div>



<table cellpadding="2" cellspacing="2" width="100%">
    <tr>
        <th scope="col">File</th>
        <th style="width:130px" scope="col">Caption</th>
        <th style="width:130px" scope="col">Message</th>
        <th scope="col">Description</th>
        <th scope="col">Author</th>
        <th scope="col"></th>
    </tr>

    <?php foreach($blocksInfos as $blockDetail): ?>

    <tr class="block" id="file_<?php echo $blockDetail['filechunk']; ?>">
        <td><?php echo $blockDetail['file']; ?></td>
        <td style="width:130px"><?php echo $blockDetail['caption']; ?></td>
        <td style="width:130px"><?php echo $blockDetail['message']; ?></td>
        <td><?php echo $blockDetail['description']; ?></td>
        <td><a href="<?php echo $blockDetail['homepage']; ?>"><?php echo $blockDetail['author']; ?></a></td>
        <td>
            <button onclick="editBlock('<?php echo $blockDetail['filechunk']; ?>', this)">Edit</button>
            <button id="switch<?php echo $blockDetail['filechunk']; ?>" value="<?php echo $blockDetail['filechunk']; ?>" onclick="switchBlock('<?php echo $blockDetail['filechunk']; ?>', this)">
               <?php if($blockDetail['active']): ?>Deactivate<?php else: ?>Activate<?php endif; ?>
            </button>
        </td>
    </tr>

    <?php endforeach; ?>

</table>


<?php endif;
} // end blocksmenu ?>