<?php
/*
   BloxPress2
   ----------------------
   Copyright (C) 2006, Kjell Bublitz
   www.bloxpress.org / kb@bloxpress.org

   Bloxpress Adminpage: Presets

   layout_themefolder_name.xml

*/

add_action('admin_menu', 'bloxpress_layouts');
function bloxpress_layouts() { add_submenu_page('themes.php', 'Bloxpress Preset', 'Bloxpress Preset', 5, BP_BASEDIR.'/system/admin_layouts.php', 'bloxpress_layoutHTML'); }

function bloxpress_layoutHTML()
{
    global $message, $bloxpressColumns, $themeData;

    include_once(BP_BASEDIR.'/system/phplibs/class.xml.php');
    $xmlblocks = file_get_contents(BP_BASEDIR.'/system/workdir/blocks.xml');
    $phpblocks = XML_unserialize($xmlblocks);
    $blocks = $phpblocks['bloxpress']['block'];

    // Get Blocks and FileInfo
    if(is_dir(BP_BLOCKDIR)) {
        $blocksInfos = array(); $i=0;
        $blockdir = opendir(BP_BLOCKDIR);
        while (($blockfile = readdir($blockdir)) !== false) {
            if($blockfile != '.' && $blockfile != '..' && $blockfile != 'CVS' && $blockfile != 'icons'){
                $blockchunk = explode('.', $blockfile);
                $blocksInfos[$i] = bp_get_block_data(BP_BLOCKDIR.'/'.$blockfile);
                $blocksInfos[$i]['active'] = false;
                $blocksInfos[$i]['file'] = $blockfile;
                $blocksInfos[$i]['filechunk'] = $blockchunk[0];
                if(is_array($blocks)) {
                    foreach($blocks as $block) {
                        if($block['file'] == $blockfile){ $blocksInfos[$i]['active'] = true; break; }
                    }
                }
            }
            $i++;
        }
    }

    // get presets and template
    $presets = get_option( 'bp_presets' );
    $template = get_option( 'bp_template' );
    $preset_names = array_keys($presets);
    $presetcount = 0;
    foreach($preset_names as $preset ){
        if($preset == $template) {
            $layout_names = array_keys($presets[$template]);
            foreach($layout_names as $layout) {
                $presetcount++;
                $layoutlist.='<option value="'.$layout.'">'.ucfirst($layout).'</option>';
            }
        }
    }

    if($_POST['do'] == 'editlayout') {
       $layout = $presets[$template][$_POST['layout']];
    }

    if($_POST['do'] == 'addlayout') {
       $layout = $presets[$template][$_POST['layoutnew']];
    }

    if($_POST['do'] == 'removelayout') {
        unset($presets[$template][$_POST['layoutkill']]);
        update_option('bp_presets', $presets);
        $message = 'Preset '.$_POST['layoutkill'].' has been trashed. Refreshing in 2 seconds';
        $url = 'http://'.$_SERVER['HTTP_HOST'] . $_SERVER['PHP_SELF'].'?page='.$_GET['page'];
        echo '<meta http-equiv="refresh" content="2; URL='.$url.'">';
    }

    for($a=0; $a <count($bloxpressColumns); $a++){
        $containment .= "'col_" . $a . "'";
        if( $a != count($bloxpressColumns)-1 ){
            $containment .= ",";
        }
    }


if(get_option('bp_version')):
?>
<script src="<?php echo BP_BASEURL; ?>/system/javascript/libraries/prototype.js" type="text/javascript"></script>
<script src="<?php echo BP_BASEURL; ?>/system/javascript/bloxpress/bp_cookie.js" type="text/javascript"></script>
<script src="<?php echo BP_BASEURL; ?>/system/javascript/scriptaculous/effects.js" type="text/javascript"></script>
<script src="<?php echo BP_BASEURL; ?>/system/javascript/scriptaculous/dragdrop.js" type="text/javascript"></script>
<script src="<?php echo BP_BASEURL; ?>/system/javascript/scriptaculous/builder.js" type="text/javascript"></script>

<?php if($message){ ?>
    <div id="message" class="updated fade"><p><?php echo $message ?></p></div>
<?php } ?>
    <div id="dropmessage" class="updated" style="display:none;"></div>


<div class="wrap">
    <h2>Preset Manager</h2>
    <p>In this menu you can add blocks and change the overall arrangement of a template preset.</p>

    <p>Your currently selected template is: <strong><?php echo $template; ?></strong><br />
    This template has <?php echo $presetcount; ?> layout-presets.</p>

    <table width="99%">
    <tr style="background:#fafafa"><td><strong>Edit existing</strong></td><td><strong>Add new</strong></td><td><strong>Remove existing</strong></td></tr>
    <tr>
        <td width="33%">
         <form action="" method="post">
        <input type="hidden" name="do" value="editlayout" />
        <select name="layout">
            <?php echo $layoutlist; ?>
        </select>
        <button type="submit">Edit</button><br />
        <small>Here you can change block arrangement</small>
        </form>
        </td>

        <td width="33%">
        <form action="" method="post">
        <input type="hidden" name="do" value="addlayout" />
        <input type="text" name="layoutnew" size="20">
        <button type="submit">Add</button><br />
        <small>No spaces or special stuff! Single words!</small>
        </form>
        </td>

        <td width="33%">
        <form action="" method="post">
        <input type="hidden" name="do" value="removelayout" />
        <select name="layoutkill">
            <?php echo $layoutlist; ?>
        </select>
        <button type="submit">Remove</button><br />
        <small>This can't be undone!</small>
        </form>
        </td>
    </tr>
    </table>
    <br /><br />
    <style type="text/css">
        .hover { border: 1px dashed #000 }
    </style>


    <?php if($_POST['do'] == 'addlayout'): ?>
    <h2>Adding: <?php echo ucfirst($_POST['layoutnew']); ?></h2>
    <?php endif; ?>

    <?php if($_POST['do'] == 'editlayout'): ?>
    <h2>Editing: <?php echo ucfirst($_POST['layout']); ?></h2>
    <?php endif; ?>

<?php if($_POST['do'] == 'addlayout' || $_POST['do'] == 'editlayout'): ?>
    <table width="100%" cellpadding="3" cellspacing="5">
        <tr>
            <td colspan="<?php echo count($bloxpressColumns); ?>">
                <strong>Available Blocks:</strong>
                <ul id="blockmenu" style="padding:0;margin:0;">
                    <?php $menuitems=0; foreach($blocksInfos as $blockDetail): ?>
                    <?php if($blockDetail['active']): $jsBlockArr.="'".$blockDetail['filechunk']."',"; ?>

                    <li id="<?php echo $blockDetail['filechunk']; ?>" class="menuitem" style="font-size:0.9em;display:inline;cursor:move;margin:4px;float:left">
                        <p><?php echo $blockDetail['caption']; ?></p>
                        <p style="display:none;"><?php echo $blockDetail['file']; ?></p>
                        <p style="display:none;"><?php echo $blockDetail['message']; ?></p>
                    </li>
                    <?php endif; ?>
                    <?php $menuitems++; endforeach; ?>
                </ul>
                <br clear="all" />

                <div style="text-align:right">
                    <div id="trash" style="float:right;background:#cc0000;width:70px;text-align:center;color:#fff;"> TrashCan </div>
                    <small>Drop blocks from below on here to remove them. &nbsp;</small>
                    <br clear="all" />
                </div>
            </td>
        </tr>


    <?php if($_POST['do'] == 'editlayout'): ?>
        <tr style="background:#fafafa;">
        <?php for($c=0; $c < count($bloxpressColumns); $c++):  ?>
            <td valign="top" width="25%"><h3><?php echo $bloxpressColumns[$c]; ?></h3>
                <ul style="padding:0 !important;margin:0 !important;padding-bottom:30px !important" id="col_<?php echo $c; ?>">
                <?php for($i=0; $i < count($layout['bloxpress']['column'][$c]['block']); $i++): ?>
                    <li class="block" id="block_<?php echo str_replace('.php','',$layout['bloxpress']['column'][$c]['block'][$i]['file']).$c.$i; ?>" style="font-weight:bold;padding-left:5px;width:70%;list-style:none;cursor:move;border:1px solid #aaa;background:#efefef">
                         <p><?php echo $layout['bloxpress']['column'][$c]['block'][$i]['caption']; ?></p>
                         <p style="display:none;"><?php echo $layout['bloxpress']['column'][$c]['block'][$i]['file']; ?></p>
                         <p style="display:none;"><?php echo $layout['bloxpress']['column'][$c]['block'][$i]['message']; ?></p>
                    </li>
                <?php endfor; ?>
                </ul>
            </td>
        <?php endfor; ?>
        </tr>
    <?php endif; ?>

    <?php if($_POST['do'] == 'addlayout'): ?>
        <tr style="background:#fafafa;">
            <?php for($c=0; $c < count($bloxpressColumns); $c++):  ?>
                <td valign="top" width="25%"><h3><?php echo $bloxpressColumns[$c]; ?></h3>
                    <ul style="padding:0 !important;margin:0 !important;padding-bottom:30px !important" id="col_<?php echo $c; ?>">

                    </ul>
                </td>
            <?php endfor; ?>
        </tr>
    <?php endif; ?>
    </table>
<?php endif; ?>
    <div id="info" style="display:none;background:#ffb;color:#000;font-weight:bold;float:left;"></div>
    <br clear="all" />

    <?php if($_POST['do'] == 'addlayout' || $_POST['do'] == 'editlayout'): ?>
    <script type="text/javascript">

        var columns = new Array(); var layout = new Array();
        var presCookie = new BloxpressCookie('bp2apres', '', false, 20000);
        <?php for($a=0; $a <count($bloxpressColumns); $a++){ ?>
        columns.push('col_<?php echo $a; ?>');
        <?php } ?>
        <?php $jsBlockArr = $jsBlockArr."'#'"; ?>
        var blockMenuItemIds = new Array(<?php echo $jsBlockArr; ?>);

       Droppables.add('trash', {
            accept:'block', zindex: 1000, hoverclass:'hover', onDrop:function(element, droppableElement) {
                Element.remove(element);
            }
        });

        function makeSortable() {
            for (var c = 0; c < columns.length; c++) {
                Sortable.create(columns[c], {revert: true,
                    constraint:false,dropOnEmpty:true,ghosting:false,
                    containment:[<?php echo $containment; ?>],
                    onChange:function(){},
                    onUpdate:function(){serializeAll();}
                });
            }
        }
        makeSortable();

        function makeDraggable() {
            for (var b = 0; b < (blockMenuItemIds.length)-1; b++) {
                new Draggable(blockMenuItemIds[b], { revert:true, ghosting:true });
            }
        }
        makeDraggable();

        function makeDroppable() {
            for (var c = 0; c < columns.length; c++) {
               Droppables.add(columns[c], {
                    accept:'menuitem', zindex: 1000, hoverclass:'hover', onDrop:function(element, droppableElement) {
                        addDropped(element, droppableElement)
                    }
                });
            }
        }
        makeDroppable();

        function addDropped(liElement, column) {
            Element.cleanWhitespace(column);
            Element.cleanWhitespace(liElement);

            var colsplit = column.id.split('_');
            var blox = column.childNodes.length;
            var cnr = colsplit[1];
            var chk = liElement.id;
            var lid = chk+cnr+blox;
            var cap = liElement.childNodes[0].innerHTML;
            var fil = liElement.childNodes[1].innerHTML;
            var msg = liElement.childNodes[2].innerHTML;

            // Create / Add
            var menuItem = Builder.node('li', {id:'block_'+lid, className:'block', style:'font-weight:bold;padding-left:5px;width:70%;list-style:none;cursor:move;border:1px solid #aaa;background:#efefef'}, [
            Builder.node('p', cap), Builder.node('p', {style:'display:none'}, fil), Builder.node('p', {style:'display:none'}, msg)]);
            column.appendChild(menuItem);

            // Populate
            makeSortable();
            serializeAll();
        }

        function serializeAll()
        {

            var cols = new Array();
            var blocks = new Array();
            for(var i=0;i < columns.length;i++) {
                console.log(columns[i]);
                var seq = Sortable.sequence(columns[i]);
                console.log(seq);
                for(var s=0;s < seq.length;s++)
                {
                    var ele = $('block_'+seq[s]);
                    Element.cleanWhitespace(ele);

                    var eleB = new Array();
                    eleB.push('B_'+i+'_'+ele.childNodes[0].innerHTML);
                    eleB.push(ele.childNodes[1].innerHTML);
                    eleB.push(ele.childNodes[2].innerHTML);

                    blocks.push(eleB);
                }
            }
            cols.push(blocks);
            presCookie.cookieValue = cols;
            presCookie.update();
            $("info").innerHTML = ''; Element.show($("info"));
            <?php if($_POST['do'] == 'addlayout'): ?>
            new Ajax.Updater('info', '<?php echo BP_BASEURL; ?>/system/admin_ajax.php?do=savePreset&t=<?php echo $template; ?>&p=<?php echo $_POST['layoutnew']; ?>&cookie='+document.cookie, {evalScripts:true});
            <?php endif; ?>

            <?php if($_POST['do'] == 'editlayout'): ?>
            new Ajax.Updater('info', '<?php echo BP_BASEURL; ?>/system/admin_ajax.php?do=savePreset&t=<?php echo $template; ?>&p=<?php echo $_POST['layout']; ?>&cookie='+document.cookie, {evalScripts:true});
            <?php endif; ?>

            makeSortable();
            makeDroppable();
        }

    </script>
    <?php endif; ?>

</div>

<?php endif; } ?>