<?php
/*
   BloxPress2
   ----------------------
   Copyright (C) 2006, Kjell Bublitz
   www.bloxpress.org / kb@bloxpress.org

   Bloxpress Adminpage: System

*/
add_action('admin_menu', 'bloxpress_system');
function bloxpress_system() { add_submenu_page('themes.php', 'Bloxpress System', 'Bloxpress System', 5, BP_BASEDIR.'/system/admin_system.php', 'bloxpress_systemHTML'); }

function bloxpress_systemHTML()
{
    global $message, $themeData;

    if($_POST['uninstall']=='now')
    {
        delete_option('bp_version');
        delete_option('bp_template');
        delete_option('bp_options');
        delete_option('bp_presets');

    	$message = 'Uninstall complete.';
    }

    if($_POST['checkOnline']=='now')
    {
        $onlineversion = bp_check_online();
    }

    if($_POST['update']=='now')
    {
        $bpOptions = get_option('bp_options');
        $bpOptions['minOnMove'] = $_POST['bp_minOnMove'];
        $bpOptions['ghostEffect'] = $_POST['bp_ghostEffect'];

        $bpOptions['draggableClass'] = $_POST['bp_dragHandleClass'];
        $bpOptions['postContentClass'] = $_POST['bp_postContentClass'];
        $bpOptions['hoverClassName'] = $_POST['bp_hoverClass'];
        $bpOptions['enableHover'] = $_POST['bp_hoverEnabled'];

        $bpOptions['sortableTag'] = $_POST['bp_sortableTag'];
        $bpOptions['sortableRoot'] = $_POST['bp_sortableRoot'];

        $bpOptions['updateMessage'] = $_POST['bp_updateMessage'];
        $bpOptions['updateMessageTop'] = $_POST['bp_updateMessageTop'];
        $bpOptions['updateMessageLeft'] = $_POST['bp_updateMessageLeft'];
        $bpOptions['cookieDays'] = $_POST['bp_keepCookieDays'];

        update_option( 'bp_options', $bpOptions );

        $themeData = bp_get_theme_data( BP_BASEDIR . '/templates/'.get_option('bp_template').'/style.css' );

        switch(bp_write_js_config())
        {
            case '1': $message = 'Settings saved. Config saved. :) Refreshing in 1, 2..';
            $url = 'http://'.$_SERVER['HTTP_HOST'] . $_SERVER['PHP_SELF'].'?page='.$_GET['page'];
            echo '<meta http-equiv="refresh" content="2; URL='.$url.'">';

            break;
            case '2': $message = 'Settings saved. Config could not be opened for writing (system/cache/).'; break;
            case '3': $message = 'Settings saved. Config could not be written. (system/cache/).'; break;
        }


    }

    // show menu
    if(get_option('bp_version')):
    $bpOptions = get_option('bp_options');
    $localversion = get_option('bp_version');
?>

<?php if($message){ ?>
    <div id="message" class="updated fade"><p><?php echo $message ?></p></div>
<?php } ?>
    <div id="dropmessage" class="updated" style="display:none;"></div>
    <script src="<?php echo BP_BASEURL; ?>/system/javascript/libraries/prototype.js" type="text/javascript"></script>

<div class="wrap">

<h2>Online Version Check</h2>

    You are running Bloxpress2 v<?php echo $localversion; ?><br />

    <?php if($_POST['checkOnline']=='now'): ?>
    Latest available version is: v<?php echo $onlineversion; ?>
    <?php endif; ?>
    <form action="" method="post">
        <input type="hidden" name="checkOnline" value="now" />
        <input type="submit" value="Check for update" />
    </form>

    <?php if($_POST['checkOnline']=='now'): ?>
        <p style="background-color:#ffa;padding:1em;margin-bottom:2em">
            <?php if($localversion < $onlineversion): ?>
                <strong>NEW VERSION <?php echo $onlineversion; ?> AVAILABLE!</strong><br />
                Visit <a href="http://www.bloxpress.org" target="_blank">bloxpress.org</a> for update info
            <?php else: ?>
                <strong>You are running the latest version.</strong><br />

            <?php endif; ?>
        </p>
    <?php endif; ?>

<br /><br />
<form action="" method="post" name="bloxpress">
<input type="hidden" name="update" value="now" />

    <h2>Advanced Settings</h2>

    <table class="editform" cellpadding="5" cellspacing="2" width="100%">

            <tr valign="top"><td colspan="2"><h3>Performance Options</h3></td></tr>

               <tr valign="top"><th scope="row" width="33%"><label for="opt32">Minimize on Move</label></th>
                    <td><?php if($bpOptions['minOnMove'] == 'true'){echo ' <span style="color:green">Enabled!</span> ';}else{echo ' <span style="color:red">Disabled</span> '; } ?>
                    <select id="opt32" name="bp_minOnMove">
                        <option value="true"<?php if($bpOptions['minOnMove'] == 'true'){echo ' selected';} ?>>Enable minOnMove</option>
                        <option value="false"<?php if($bpOptions['minOnMove'] == 'false'){echo ' selected';} ?>>Disable minOnMove</option>
                    </select><br /><small>If enabled a block will be temporarly folded if you move it around</small></td>
                </tr>

               <tr valign="top"><th scope="row" width="33%"><label for="opt23">Ghost-Effect</label></th>
                    <td><?php if($bpOptions['ghostEffect'] == 'true'){echo ' <span style="color:green">Enabled!</span> ';}else{echo ' <span style="color:red">Disabled</span> '; } ?>
                    <select id="opt23" name="bp_ghostEffect">
                        <option value="true"<?php if($bpOptions['ghostEffect'] == 'true'){echo ' selected';} ?>>Enable Ghosting</option>
                        <option value="false"<?php if($bpOptions['ghostEffect'] == 'false'){echo ' selected';} ?>>Disable Ghosting</option>
                    </select><br /><small>If enabled each block will leave a clone on the original position to visualize origin</small></td>
                </tr>

            <tr valign="top"><td colspan="2"><h3>CSS Options</h3></td></tr>

                <tr valign="top"><th scope="row" width="33%"><label for="opt15">CSS Classname: Drag Handle</label></th><td><input id="opt15" type="text" name="bp_dragHandleClass" value="<?php echo $bpOptions['draggableClass']; ?>" size="30" /><br /><small>Dragging will be activated if clicked on elements with this class</small></p>
                <tr valign="top"><th scope="row" width="33%"><label for="opt16">CSS Classname: Post-content</label></th><td><input id="opt16" type="text" name="bp_postContentClass" value="<?php echo $bpOptions['postContentClass']; ?>" size="30" /><br/><small>Swapping postcontent and other related functions will work on elements with this class</small></p>
                <tr valign="top"><th scope="row" width="33%"><label for="opt18">CSS Classname: Hover Class</label></th><td><input id="opt18" type="text" name="bp_hoverClass" value="<?php echo $bpOptions['hoverClassName']; ?>" size="30" /><br /><small>This class will be applied to Bloxpress Columns if a block is dragged over it</small></p>

                <tr valign="top"><th scope="row" width="33%"><label for="opt17">Column-Hovereffect</label></th>
                    <td><?php if($bpOptions['enableHover'] == 'true'){echo ' <span style="color:green">Enabled!</span> ';}else{echo ' <span style="color:red">Disabled</span> '; } ?>

                    <select id="opt17" name="bp_hoverEnabled">
                        <option value="true"<?php if($bpOptions['enableHover'] == 'true'){echo ' selected';} ?>>Enable Hover Class</option>
                        <option value="false"<?php if($bpOptions['enableHover'] == 'false'){echo ' selected';} ?>>Disable Hover Class</option>
                    </select><br /></td>
                </tr>

            <tr valign="top"><td colspan="2"><h3>Column Elements</h3><p>A column (aka. sidebar) mostly consists of an unordered list and list items which hold the content. Per default Bloxpress generates its columns this way but if you ever encounter a template that works otherwise you can change them accordingly. Note that there can be numerous problems. Be careful.</p></td></tr>

                <tr valign="top"><th scope="row" width="33%"><label for="opt20">A columns root element</label></th><td><input id="opt20" type="text" name="bp_sortableRoot" value="<?php echo $bpOptions['sortableRoot']; ?>" size="10" /></td></tr>
                <tr valign="top"><th scope="row" width="33%"><label for="opt19">The child elements (blocks)</label></th><td><input id="opt19" type="text" name="bp_sortableTag" value="<?php echo $bpOptions['sortableTag']; ?>" size="10" /></td></tr>

            <tr valign="top"><td colspan="2"><h3>Cookies</h3><p>This is the small notice that pops up if the layout is getting changed. It is a fixed div containing the text which you can change here. Furthermore you can set the position by changing the CSS Top and Left propertie if you want.</p></td></tr>

                <tr valign="top"><th scope="row" width="33%"><label for="opt4">Update Message</label></th><td><input id="opt4" type="text" name="bp_updateMessage" value="<?php echo $bpOptions['updateMessage']; ?>" size="20" /></td></tr>
                <tr valign="top"><th scope="row" width="33%"><label for="opt21">CSS Top Position</label></th><td><input id="opt21" type="text" name="bp_updateMessageTop" value="<?php echo $bpOptions['updateMessageTop']; ?>" size="10" /></td></tr>
                <tr valign="top"><th scope="row" width="33%"><label for="opt22">CSS Left Position</label></th><td><input id="opt22" type="text" name="bp_updateMessageLeft" value="<?php echo $bpOptions['updateMessageLeft']; ?>" size="10" /</td></tr>
                <tr valign="top"><th scope="row" width="33%"><label for="opt25">Cookie Life</label></th><td><input id="opt25" type="text" name="bp_keepCookieDays" value="<?php echo $bpOptions['cookieDays']; ?>" size="10" /><br /><small>Define, in days, how long a cookies should stay valid</small></p>
    </table>

    <p style="text-align:right;"><input type="reset" value="Discard Changes" /> <input type="submit" value="Save Settings" /></p>
</form>

<br /><br />
<h2>Uninstall Bloxpress</h2>
<form action="" method="post" onsubmit="return confirm('Are you sure you wanna do this?')">
    <input type="hidden" name="uninstall" value="now" />
    <p>If you want to uninstall Bloxpress2 then click the button below.</p>
    <p>Cleans all your preferences!</p>
    <input type="submit" value="Uninstall" /></p>
</form>

</div>

    <? else: ?>
    <div class="wrap" style="position:relative;">

        <h2>Thanks for using Bloxpress2</h2>
        <p>I hope you enjoyed it. Visit <a href="http://www.bloxpress.org">www.bloxpress.org</a> for latest infos.</p>
        <p>If you had other reasons for uninstalling rather then just to change the look of your site, please let me know so i can improve Bloxpress based on your expirience.</p>

        <h3>Have a nice day!</h3>
        <p style="text-align:right;color:#888"><small>Uninstalled by accident? Don't worry. Refresh the page to restore Bloxpress default options.</small></p>
    </div>
    <? endif;
    } // endoptions
    ?>