<?php
/*
   BloxPress2
   ----------------------
   Copyright (C) 2006, Kjell Bublitz
   www.bloxpress.org / kb@bloxpress.org

   Bloxpress Layout Loop

*/
    include_once( BP_BASEDIR . '/system/phplibs/class.xml.php' );
    $bpOptions = get_option( 'bp_options' );
    $bpTemplate = get_option( 'bp_template' );
    $bpPresets = get_option( 'bp_presets' );


    // get all installed blocks
    // =========================================================================
    $blocks = file_get_contents( BP_BASEDIR . '/system/workdir/blocks.xml' );
    $blocks = XML_unserialize( $blocks );
    $blocks = $blocks['bloxpress']['block'];

    // setup arrays
    // =========================================================================
    $column_blocks = array();
    $column_count = array();

    if ( !isset( $_COOKIE['bp2layout'] ) ) { // use XML
        if ( isset( $_COOKIE['bp2preset'] ) ) { // use preset cookie
            $layout = $bpPresets[$bpTemplate][$_COOKIE['bp2preset']]; // try current template
            if(count($layout) == 0) { // no setup
                $layout = $bpPresets['default']['default']; // fallback default
            }
        } else {
            $preset_templates = array_keys($bpPresets); // get templates
            if(in_array($bpTemplate, $preset_templates)){ // search current in all
                $template_layouts = array_keys($bpPresets[$bpTemplate]); // get presets
                if(count($template_layouts) == 0) { // no setups for this template
                    $layout = $bpPresets['default']['default']; // fallback default
                } else { // use the first avail, no cookie said different
                    $layout = $bpPresets[$bpTemplate][$template_layouts[0]];
                    // makes sure that fresh admin layout is visible on page refresh
                }
            } else { // template is not in the preset array.
                $layout = $bpPresets['default']['default'];
            }
        }

        // get layout columns
        $layoutcols = $layout['bloxpress']['column'];
        $layoutcols_num = count( $layoutcols );

        // setup layout array
        for( $c = 0;$c < $layoutcols_num;$c++ ) {
            $column_blocks[$c] = $layoutcols[$c]['block'];
            $column_count[$c] = count( $layoutcols[$c]['block'] );
        }

    } else { // use Cookie

        $layoutcookie = $_COOKIE['bp2layout'];

        // break cookie in half
        $columns = explode( '##', $layoutcookie );
        $columns_num = count( $columns ); // (noo, they broke ma cookie!)

        // fix single column layouts
        if ( $columns_num < 1 ) {
            $columns = array( $layoutcookie );
            $columns_num = 1;
        }
        // create layout
        for( $c = 0;$c < $columns_num;$c++ ) { // for each column
            $column_items[$c] = explode( ',', $columns[$c] ); // explode serialized cookie
            if ( !empty( $columns[$c] ) ) {
                $column_count[$c] = count( $column_items[$c] ); // count number of blocks
                for( $i = 0;$i < $column_count[$c];$i++ ) { // and for each block within
                    $block_realname = explode( '_', $column_items[$c][$i] ); // strip randomid from value
                    $block_filename = $block_realname[0] . '.php'; // set focus to this file
                    for( $x = 0;$x < count( $blocks );$x++ ) { // go through the blocks.xml
                        if ( $blocks[$x]['file'] == $block_filename ) { // if match a entry, append
                            $column_blocks[$c][$i]['caption'] = $blocks[$x]['caption'];
                            $column_blocks[$c][$i]['file'] = $block_filename;
                        }
                    }
                }
            } else {
                $column_count[$c] = 0;
            }
        }
    }

    function bp_draw_column( $column_id, $blockclass='', $colclass='' )
    {
        global $bloxpressColumns, $themeData, $column_count, $column_blocks, $bpOptions;

        // read min-max-block-cookie
        $minimizedBlocks = explode( ',' , $_COOKIE['bp2blocks'] );

        // search requested column
        for( $c = 0;$c < count( $bloxpressColumns );$c++ ) {
            $column = $bloxpressColumns[$c];

            // if found column
            if ( $column == $column_id ) {

                // create column
                $columnHTML = '<' . $bpOptions['sortableRoot'] . ' id="' . $column . '">';

                // inject class if requested
                if($colclass != "") {
                    $columnHTML = '<' . $bpOptions['sortableRoot'] . ' id="' . $column . '" class="'.$colclass.'">';
                }


                for( $i = 0;$i < $column_count[$c];$i++ ) {

                    // if we have a blockfile to include
                    if ( $column_blocks[$c][$i]['file'] != "" ) {
                        $bStyle = "block"; // visible by default

                        // create unique id
                        $typeid = str_replace( strchr( $column_blocks[$c][$i]['file'], '.' ), '', $column_blocks[$c][$i]['file'] );
                        $dragid = 'draggable' . $c . '_' . $typeid . '_' . $i;

                        // create block header HTML
                        $blockHTML = '<div class="caption"><h3 class="' . $bpOptions['draggableClass'] . '">' . $column_blocks[$c][$i]['caption'] . '</h3>';
                        $blockHTML .= '<a href="javascript:;" class="remove noscript" title="Remove this block">';
                        $blockHTML .= '<img src="' . BP_CURRENTURL . '/' . $themeData['imgdir'] . '/' . $bpOptions['closeIconImage'] . '" alt="(X)" /></a>';
                        $blockHTML .= '<a href="javascript:;" class="minmax noscript" title="Minimize this block">';
                        $blockHTML .= '<img src="' . BP_CURRENTURL . '/' . $themeData['imgdir'] . '/' . $bpOptions['minIconImage'] . '" alt="(+)" /></a>';
                        $blockHTML .= '</div>';

                        // minimize blocktype if set in cookie
                        if ( is_array( $minimizedBlocks ) ) {
                            if ( in_array( $typeid, $minimizedBlocks ) ) {
                                $bStyle = "hideContent";
                            }
                        }

                        // include blockcontent, cache output
                        ob_start();
                            include( BP_BLOCKDIR . '/' . $column_blocks[$c][$i]['file'] );
                            $blockHTML .= ob_get_contents();
                        ob_end_clean();

                        // inject class if requested
                        if($blockclass != "") {
                            $blockclass = " ".$blockclass;
                        }

                        // append this block
                        $columnHTML .= "\n<" . $bpOptions['sortableTag'] . " id=\"" . $dragid . "\" class=\"" . $bStyle . $blockclass ."\">\n";
                        $columnHTML .= $blockHTML;
                        $columnHTML .= "</" . $bpOptions['sortableTag'] . ">\n";
                    }
                }
                // finish column
                $columnHTML .= "</" . $bpOptions['sortableRoot'] . ">\n";

                // spit it out
                print( $columnHTML );
            }
        }
    }

    // DEBUG
    if ( BP_DEBUG ) {
        echo '<br/>columns: ' . $columns_num;
        echo '<pre>';
        echo 'templateData: ';
        print_r( $themeData );
        if ( isset( $_COOKIE['bp2layout'] ) ) {
            echo 'cookie';
            print_r( $column_items );
        } else {
            echo 'laycols';
            print_r( $layoutcols );
        }
        echo 'count';
        print_r( $column_count );
        echo 'blocks';
        print_r( $column_blocks );
        echo '</pre>';
        exit;
    }
?>