/**
 * BloxPress2
 * ----------------------
 * Copyright (C) 2006, Kjell Bublitz
 * www.bloxpress.org
 *
 * @fileoverview Bloxpress Generic Ajax Class
 * @author Kjell Bublitz kb@bloxpress.org
 * @version 1.2
 */
var BloxpressAjaxRequest = Class.create();
BloxpressAjaxRequest.prototype = {
/**
 * Takes advantage of the random Id. Basicly made for custom blocks that want to use Ajax.
 * Maybe i gonna extend this if necessary... XML would fit pretty well.
 *
 * @param {Integer} randomId The value of hiddenRandom
 * @param {String} block (optional) Switch special rules
 * @param {String} resultDiv (optional) The target div where the content shall be loaded
 * @param {String} queryForm (optional) The Name of the Form
 * @param {String} queryUrl (optional) URL of the form handler script.
 */
    initialize: function(block, randomId, resultDiv, queryForm, queryUrl)
    {
        if (block != null && block.length > 1) // apply special rule
        {
            switch (block)
                    {
            // technorati
                case 'technorati':
                    var queryForm = 'technoform';
                    var queryUrl = 'bcode/block_technorati.php?type=search';
                    break;

                // delicious
                case 'delicious':
                    var queryForm = 'deliform';
                    var queryUrl = 'bcode/block_delicious.php?show=10';
                    break;

                // rss feed
                case 'rssfeed':
                    var queryForm = 'rssform';
                    var queryUrl = 'bcode/block_rssfeed.php';
                    break;

                // flickr block
                case 'flickr':
                    var queryForm = 'flickrform';
                    var queryUrl = 'bcode/block_flickr.php';
                    break;
            }
        }

        // create loading animation
        var waitAnimation = Builder.node('p', {className:'searching'}, [
                Builder.node('img', {src:searchImagePath, alt:'searching...'})
                ]);

        // setup target vars
        var contentDiv = 'results' + randomId;
        var contentUrl = tplpath + queryUrl;
        var requestForm = queryForm + randomId;

        // do the request
        new Ajax.Updater(contentDiv, contentUrl, {
            onLoading:function() {
                $(contentDiv).appendChild(waitAnimation)
            },
            parameters:Form.serialize(requestForm),
            asynchronous:true,
            evalScripts:true
        });
    }
}
