/**
 * BloxPress2
 * ----------------------
 * Copyright (C) 2006, Kjell Bublitz
 * www.bloxpress.org
 *
 * @type: Extension
 * @fileoverview Bloxpress XML Menu Class
 * @author Kjell Bublitz kb@bloxpress.org
 * @version 1.4
 */
BloxpressBlocks = Object.extend(Bloxpress,{
    blocksMenuIdle: new Boolean(true),
    blocksMenuItemIds: new Array(),
    blocksFetch: function() {
        getXML = new Ajax.Request(tplpath + 'system/workdir/blocks.xml', {
            method:'get', requestHeaders:['cache-control','no-cache','pragma','no-cache'],
            onComplete:function(xmlresult) {
                if(xmlresult.responseXML.firstChild.nodeName == 'bloxpress') {
                    Bloxpress.blocksParse(xmlresult.responseXML);
                } else {
                    var blockMenuDiv = Builder.node('div', {id:'contentmenu', style:'display:none'},['No Blocks availble']);
                    $(blockMenuTarget).appendChild(blockMenuDiv);
                    Bloxpress.blocksMenu = $('contentmenu');
                }
            }
        });
    },
    blocksApply: function() {
        this.blocksDraggables();
        this.blocksDroppables();
    },
    blocksParse: function(xmlDoc) {
        var blockArray = new Array();
        var xmlBlocks = xmlDoc.getElementsByTagName('block');
        for (var i = 0; i < xmlBlocks.length; i++)
        {
            blockArray[i] = new Object();
            blockArray[i]['file'] = Bloxpress.xmlValue(xmlBlocks[i], 'file');
            blockArray[i]['caption'] = Bloxpress.xmlValue(xmlBlocks[i], 'caption');
            blockArray[i]['message'] = Bloxpress.xmlValue(xmlBlocks[i], 'message');
            this.blocksMenuItemIds.push('content_' + blockArray[i]['file'].split('.')[0]);
        }
        this.blocksMenuItems = blockArray;
        this.blocksCreateMenu();
    },
    blocksCreateMenu : function() {
        var blockMenuItemShort, blockMenuItemId, blockMenuItemTitle, blockMenuItemIcon;
        // create list, title and help text
        var blockMenuList = Builder.node('ul');
        var blockFloatBrk = Builder.node('br', {style:'clear:both'});
        var blockMenuTitle = Builder.node('h3', {id:'contentmenu-drag',style:'cursor:move'}, ['Blockmenu']);
        var blockMenuHelp = Builder.node('div', {id:'contentmenu-help'}, [Builder.node('p', addblockHelp)]);
        var blockMenuNavi = Builder.node('small', {className: 'options'}, [
                Builder.node('a', {href:'javascript:;',onclick:'Effect.SwitchOff(this.parentNode.parentNode);'}, ['Close Menu']),
                ' | ',
                Builder.node('a', {href:'javascript:;',onclick:'Bloxpress.builderUndoLast();'}, ['Undo last']),
                ' | ',
                Builder.node('a', {href:'javascript:;',onclick:'Bloxpress.builderUndoAll();'}, ['Undo all'])
                ]);
        // create list items
        for (var b = 0; b < this.blocksMenuItems.length; b++) {
            blockMenuItemShort = this.blocksMenuItems[b]['file'].split('.')[0];
            blockMenuItemId = 'content_' + blockMenuItemShort;
            blockMenuItemTitle = this.blocksMenuItems[b]['caption'];
            blockMenuItemIcon = tplpath + 'blocks/icons/' + blockMenuItemShort + '.png';
            blockMenuItem = Builder.node('li', {id: blockMenuItemId, className: 'contentitem'}, [Builder.node('img', {src: blockMenuItemIcon, alt: '- '}), blockMenuItemTitle])
            blockMenuList.appendChild(blockMenuItem);
        }
        // build Menu main div
        var blockMenuDiv = Builder.node('div', {id:'contentmenu', style:'display:none'}, [
                blockMenuTitle, blockMenuList, blockFloatBrk, blockMenuHelp, blockMenuNavi
                ]);
        var targetElement = $(blockMenuTarget);
        targetElement.appendChild( blockMenuDiv );
        this.blocksMenu = $('contentmenu');
    },
    blocksMenuToggle: function() {
        Bloxpress.blocksApply();
        if (Element.visible(this.blocksMenu)) {
            Effect.SwitchOff(this.blocksMenu);
        } else {
            Effect.SwitchOn(this.blocksMenu);
        }
    },
    blocksDraggables: function() {
        menu = new Draggable(this.blocksMenu, {revert:false, ghosting:false, handle:'contentmenu-drag'})
        for (var b = 0; b < this.blocksMenuItemIds.length; b++) {
            menuItem = new Draggable(this.blocksMenuItemIds[b], { revert:true, ghosting:true });
        }
    },
    blocksDroppables: function() {
        for (var c = 0; c < Bloxpress.columns.length; c++) {
           Droppables.add(Bloxpress.columns[c], {
                accept:'contentitem', zindex: 1000, hoverclass: hoverClassName,
                onDrop:function(element, droppableElement) {
                    Bloxpress.checkDropped(element.id, droppableElement)
                }
            });
        }
    }
});