/**
 * BloxPress2
 * ----------------------
 * Copyright (C) 2006, Kjell Bublitz
 * www.bloxpress.org
 *
 * @type: Extension
 * @fileoverview Bloxpress Layout Builder
 * @author Kjell Bublitz kb@bloxpress.org
 * @version 1.5
 */
BloxpressBuilder = Object.extend(Bloxpress, {
    builderManaged: new Array(),
    builderRecovery: new Array(),
    builderRandomId: function(targetContainer)
    {
        var targetRandomID = Math.floor(Math.random() * 10000);
        var targetElements = document.getElementsByClassName('random', targetContainer);
        var targetHiddenVal = document.getElementsByClassName('hiddenRandom', targetContainer);
        targetElements.each(function(targetObject) {
            targetObject.id += targetRandomID;
        });
        targetHiddenVal.each(function(hiddenInput) {
            hiddenInput.value = targetRandomID;
        });
    },
    builderCreate: function(column, blockUrl, blockIdentfier, blockCaption, blockMessage, mode)
    {
        if (this.builderManaged == undefined) this.builderManaged = new Array();

        var newRandomId = Math.floor(Math.random() * 10000);
        var newBlockId = blockIdentfier + '_' + newRandomId;
        var newContentId = newBlockId + '_content';
        var newBlockElement = this.blockStructure(newBlockId, blockCaption, blockMessage);

        column.insertBefore(newBlockElement, column.firstChild);

        if(mode=='menu') this.builderManaged.push(newBlockId);
        Bloxpress.setupColumn(column);
        this.builderPopulate(newContentId, blockUrl);
    },
    builderPopulate: function(contentId, contentUrl)
    {
        content = new Ajax.Updater(contentId, contentUrl, {
            method: 'get', asynchronous: true, evalScripts: true,
            onComplete: function()
            {
                Bloxpress.builderRandomId(contentId);
                Bloxpress.updateCookie();
                Bloxpress.blocksApply();
                Behaviour.apply();
            }
        });
    },
    builderRecover: function(blockId) {
        for (var i = 0; i < this.builderRecovery.length; i++) {
            if (this.builderRecovery[i].trashBinId == blockId) {
                this.builderRecovery[i].restore();
                this.builderRecovery.splice(i, i);
                break;
            }
        }
    },
    builderRecoverTimer: function(blockId) {
        for (var i = 0; i < this.builderRecovery.length; i++) {
            if (this.builderRecovery[i].trashBinId == blockId) {
                this.builderRecovery[i].timeOut(); break;
            }
        }
    },
    builderRemove: function(blockElement)
    {
        this.builderRecovery.push(new BloxpressRecover(blockElement.id, blockElement, blockElement.parentNode));
        if (this.builderManaged.length > 0) {
            if (blockElement.id in this.builderManaged) {
                this.builderManaged.clear();
                for (var i = 0; i < this.builderManaged.length; i++)
                {
                    if (this.builderManaged[i] != blockElement.id) {
                        this.builderManaged.push(this.builderManaged[i]);
                    }
                }
            }
        }
        Element.remove(blockElement);
    },
    builderRemoveAll: function() {
        for (var c; c < Bloxpress.columns.length; c++) {
            Bloxpress.columns[c].innerHTML = null;
        }
        Bloxpress.updateCookie();
        this.builderManaged.clear();
    },
    builderUndoAll: function()
    {
        if (this.builderManaged != undefined) {
            if (this.builderManaged.length > 0) {
                for (var i = 0; i < this.builderManaged.length; i++) {
                    if (document.getElementById(this.builderManaged[i]) != null) {
                        Element.remove(this.builderManaged[i]);
                    }
                }
                this.builderManaged.clear();
            }
        }
        Bloxpress.updateCookie();
    },
    builderUndoLast: function()
    {
        if (this.builderManaged != undefined) {
            var managedBlocks = this.builderManaged.length;
            if (managedBlocks > 0) {
                if (document.getElementById(this.builderManaged[managedBlocks - 1]) != null) {
                    Element.remove(this.builderManaged[managedBlocks - 1]);
                    this.builderManaged.length--;
                }
            }
        }
    }
});