/**
 * BloxPress2
 * ----------------------
 * Copyright (C) 2006, Kjell Bublitz
 * www.bloxpress.org
 *
 * @type: Extension
 * @fileoverview Bloxpress Layout Updater
 * @author Kjell Bublitz kb@bloxpress.org
 * @version 1.5
 */
BloxpressLayout = Object.extend(Bloxpress, {
    layout: new Array(),
    layoutCookie: new BloxpressCookie('bp2preset'),
    layoutLoad: function(preset, theme) {
        this.template = preset;
        layoutData = new Ajax.Request(tplpath + 'system/bloxpress_xml.php?t=' + theme + '&p=' + preset, {method:'get', asynchronous:true,
            requestHeaders:['cache-control','no-cache','pragma','no-cache'],
            onSuccess:function() {
                Bloxpress.layoutUpdate();
            },
            onComplete:function(xmlresult) {
                console.log(xmlresult.responseXML);
                Bloxpress.layoutParse(xmlresult.responseXML);
            }
        });
    },
    layoutUpdate: function(){
        this.layoutCookie.cookieValue = this.template;
        this.layoutCookie.update();
    },
    layoutParse: function(xmlDoc){
        var xmlBlocks, blockAttribs;
        var xmlColumns = xmlDoc.getElementsByTagName('column');
        for (var c = 0; c < xmlColumns.length; c++)
        {
            blockAttribs = new Array();
            xmlBlocks = xmlColumns[c].getElementsByTagName('block');
            for (var b = 0; b < xmlBlocks.length; b++)
            {
                blockAttribs[b] = new Object();
                blockAttribs[b]['file'] = this.xmlValue(xmlBlocks[b], 'file');
                blockAttribs[b]['caption'] = this.xmlValue(xmlBlocks[b], 'caption');
                blockAttribs[b]['message'] = this.xmlValue(xmlBlocks[b], 'message');
            }
            this.layout.push(blockAttribs);
        }
        this.layoutApply();
    },
    layoutApply: function(){
        var currentColumn, newBlockId, newBlock;
        for (var c = 0; c < this.columns.length; c++){
            currentColumn = $(this.columns[c]);
            this.clearColumn(currentColumn);
            for (var b = 0; b < this.layout[c].length; b++){
                newBlockId = 'draggable_' + this.layout[c][b]['file'].split('.')[0] + '_' + b;
                newBlock = this.blockStructure(newBlockId, this.layout[c][b]['caption'], this.layout[c][b]['message']);
                currentColumn.appendChild(newBlock);
                newContent = new Ajax.Updater(newBlockId + '_content', tplpath + 'blocks/' + this.layout[c][b]['file'], {
                    asynchronous: true, evalScripts: true
                });
            }
        }
        this.layoutClear();
        this.initialize();
        Behaviour.apply();
        setTimeout('Bloxpress.updateCookie()', 3000);
    },
    layoutClear: function(){
        this.layout.clear();
    }
});