/**
 * BloxPress2
 * ----------------------
 * Copyright (C) 2006, Kjell Bublitz
 * www.bloxpress.org
 *
 * @type: Constructor
 * @fileoverview Bloxpress Recovery Handler
 * @author Kjell Bublitz kb@bloxpress.org
 * @version 0.6
 */
var BloxpressRecover = Class.create();
BloxpressRecover.prototype = {
    initialize: function(blockIdent, blockElement, blockOrigin) {
        this.wasTimeOut = false;
        this.trashBin = blockElement;
        this.trashBinId = blockIdent;
        this.trashBinCol = blockOrigin;
        this.trashNoteId = 'recoverNote-' + blockElement.id;
        this.trashNoteTimer = null;
        this.trashNoteTimerId = this.trashNoteId + '_t';
        this.trashBinCol.insertBefore(this.structure(), this.trashBin);
        this.timeOut();
    },
    restore: function() {
        clearTimeout(this.trashNoteTimer);
        $(this.trashNoteId).parentNode.replaceChild(this.trashBin, $(this.trashNoteId));
        this.cleanup();
    },
    structure: function() {
        return Builder.node('p', {style:'background:#fafafa;',className:'recoverNote',id:this.trashNoteId}, [
                'The Block has been removed. ',
                Builder.node('a', {href:'javascript:;',onclick:"Bloxpress.builderRecover('" + this.trashBinId + "')"}, 'Recover'),' or ',
                Builder.node('a', {href:'javascript:;',onclick:'Bloxpress.blocksMenuToggle()'}, 'add new?'),
                ' (', Builder.node('span', {id: this.trashNoteTimerId }, '6'), ')'
                ]);
    },
    timeOut: function()
    {
        if ($(this.trashNoteTimerId) != null) {
            $(this.trashNoteTimerId).innerHTML = parseInt($(this.trashNoteTimerId).innerHTML) - 1;
            if (parseInt($(this.trashNoteTimerId).innerHTML) != 0) {
                this.trashNoteTimer = setTimeout("Bloxpress.builderRecoverTimer('" + this.trashBinId + "')", 1000);
            } else {
                this.wasTimeOut = true;
                this.cleanup();
            }
        } else {
            clearTimeout(this.trashNoteTimer);
        }
    },
    cleanup: function()
    {
        if (this.trashNoteTimer != null) {
            window.clearTimeout(this.trashNoteTimer);
        }
        if (this.wasTimeOut) {
            this.trashBin = null;
            this.trashBinCol = null;
            Element.remove(this.trashNoteId);
            Bloxpress.blockManager(this.trashNoteId.split('-')[1], 'remove');
            Bloxpress.updateCookie();
        }
    }
}